
//% color="#9f32f1" iconWidth=50 iconHeight=40
namespace gravitytts {


    //% block="TTS begin" blockType="command"
    export function begin() {
        Generator.addInclude("includeDFRobot_SpeechSynthesis","#include<DFRobot_SpeechSynthesis.h>");
        Generator.addObject("asrobject","DFRobot_SpeechSynthesis_I2C","sstts");

        Generator.addSetup("setupbegin",`sstts.begin();`);
 
    }




    //% block="TTS speak [STR]" blockType="command"
    //% STR.shadow="string"  STR.defl="你好"   
    export function speak(parameter: any, block: any) {
        let str = parameter.STR.code;
        Generator.addInclude("includeDFRobot_SpeechSynthesis","#include<DFRobot_SpeechSynthesis.h>");
        Generator.addObject("asrobject","DFRobot_SpeechSynthesis_I2C","sstts");

        //if(str.substring(0,1)=="\"")  Generator.addCode(`sstts.speak(F(${str}));`);
        Generator.addCode(`sstts.speak(${str});`);
 
    }

    //% block="---"
    export function space2(){

    }

    //% block="F([STR])" blockType="reporter"
    //%STR.shadow="string"  STR.defl="你好"
    export function flashSTR(parameter: any, block: any) {
        let str = parameter.STR.code;
        Generator.addInclude("includeDFRobot_SpeechSynthesis","#include<DFRobot_SpeechSynthesis.h>");
        Generator.addObject("asrobject","DFRobot_SpeechSynthesis_I2C","sstts");

        Generator.addCode([`F(${str})`, Generator.ORDER_UNARY_POSTFIX]);
    }

    //% block="---"
    export function space1(){

    }  
    //% block="TTS set Voice[VOICE] Speed[SPEED] Tone[TONE] SoundType[SOUNDTYPE]" blockType="command"
    //% VOICE.shadow="range"  VOICE.params.min=0    VOICE.params.max=10    VOICE.defl=8
    //% SPEED.shadow="range"  SPEED.params.min=0    SPEED.params.max=10    SPEED.defl=5
    //% SOUNDTYPE.shadow="dropdown"  SOUNDTYPE.options="SOUNDTYPE"
    //% TONE.shadow="range"  TONE.params.min=0    TONE.params.max=10    TONE.defl=5
    export function setBase(parameter: any, block: any) {
        let voice = parameter.VOICE.code;
        let speed = parameter.SPEED.code;
        let type = parameter.SOUNDTYPE.code;
        let tone = parameter.TONE.code;
        Generator.addInclude("includeDFRobot_SpeechSynthesis","#include<DFRobot_SpeechSynthesis.h>");
        Generator.addObject("asrobject","DFRobot_SpeechSynthesis_I2C","sstts");

        Generator.addSetup("setupbasevoice",`sstts.setVoice(${voice});`,"true"); 
        Generator.addSetup("setupbasespeed",`sstts.setSpeed(${speed});`,"true");
        Generator.addSetup("setupbasetype",`sstts.setSoundType(sstts.${type});`,"true");
        Generator.addSetup("setupbasetone",`sstts.setTone(${tone});`,"true");
 
 
    }


    //% block="TTS setEnglishPron [PRON]" blockType="command"
    //% PRON.shadow="dropdown"  PRON.options="PRON"  
    export function setEnglishPron(parameter: any, block: any) {
        let pron = parameter.PRON.code;
        Generator.addInclude("includeDFRobot_SpeechSynthesis","#include<DFRobot_SpeechSynthesis.h>");
        Generator.addObject("asrobject","DFRobot_SpeechSynthesis_I2C","sstts");

        Generator.addSetup("setupbasepron",`sstts.setEnglishPron(sstts.${pron});`,"true");
 
    }


}
